from django.contrib.staticfiles.testing import StaticLiveServerTestCase

from selenium.webdriver.common.by import By
from selenium.webdriver.firefox.webdriver import WebDriver

class view_indexTests(StaticLiveServerTestCase):

    selenium = None

    @classmethod
    def setUpClass(cls):
        """
        Le but de cette méthode est d'initialiser selenium avant le début des tests de la classe

        """
        super().setUpClass()
        cls.selenium = WebDriver()
        cls.selenium.implicitly_wait(10)

    @classmethod
    def tearDownClass(cls):
        """
        Le but de cette méthode est de fermer selenium à la fin des tests de la classe
        """
        cls.selenium.quit()
        super().tearDownClass()

    def setUp(self) -> None:
        """
        Le but de cette méthode est que selenium soit dans l'index du site à chaque test
        """
        self.selenium.get('%s%s' % (self.live_server_url, '/recuperateur_reseau_viaire/'))

    def test_index_bouton_telechargement_ville(self):
        """
        Cette mthode test le bouton de téléchargement de la page index
        """
        self.selenium.find_element(
            By.LINK_TEXT, "Ajout"
        ).click()
        self.assertTrue(self.selenium.current_url.endswith("/recuperateur_reseau_viaire/telecharge_liste_commune"))

    def test_index_bouton_exporter(self):
        """
        Cette méthode va tester le bouton d'exportation de la base de donnée
        """
        self.selenium.find_element(
            By.LINK_TEXT, 'exporter'
        ).click()
        self.assertTrue(self.selenium.current_url.endswith("/recuperateur_reseau_viaire/export/"))

    def test_index_bouton_update_plusieurs_villes_sans_cocher_de_case(self):
        """
        Cette méthode va tester le bouton update qui permet de mettre à jour plusieurs lignes sans cocher de case
        """
        self.selenium.find_element(
            By.XPATH, '//button[@value="update"]'
        ).click()
        print("current : ", self.selenium.current_url)
        self.assertTrue(self.selenium.current_url.
                        find("/recuperateur_reseau_viaire/?bouton=update&csrfmiddlewaretoken=") != -1)
